SystemOrganization addCategory: #MudTalk!
SystemOrganization addCategory: #'MudTalk-Client'!
SystemOrganization addCategory: #'MudTalk-Obsolete'!
SystemOrganization addCategory: #'MudTalk-Tests'!

!LogicalFontManager methodsFor: '*MudTalk-Client' stamp: 'AlexanderSvyazin 1/4/2013 21:22'!
fixedWidthFamilies
	^ self allFamilies select: [ :family |
		family members allSatisfy: [ :member | member isFixedWidth ] ].! !

PPToken subclass: #MudTalkEscapeToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Client'!

!MudTalkEscapeToken methodsFor: 'processing' stamp: 'AlexanderSvyazin 1/7/2013 21:51'!
triggerOn: aTarget 
	aTarget escape: self value! !

PPToken subclass: #MudTalkTextToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Client'!

!MudTalkTextToken methodsFor: 'processing' stamp: 'AlexanderSvyazin 1/7/2013 21:47'!
triggerOn: aTarget
	aTarget unescapedText: self value! !

PPToken subclass: #TelnetAoToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Obsolete'!

!TelnetAoToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:00'!
triggerOn: aEventManager
	aEventManager triggerEvent: #ao! !

PPToken subclass: #TelnetAytToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Obsolete'!

!TelnetAytToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:01'!
triggerOn: aEventManager
	aEventManager triggerEvent: #ayt! !

PPToken subclass: #TelnetBrkToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Obsolete'!

!TelnetBrkToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:02'!
triggerOn: aEventManager
	aEventManager triggerEvent: #brk! !

PPToken subclass: #TelnetDmToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Obsolete'!

!TelnetDmToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:02'!
triggerOn: aEventManager
	aEventManager triggerEvent: #dm! !

PPToken subclass: #TelnetDoToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Obsolete'!

!TelnetDoToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:56'!
triggerOn: aEventManager
	aEventManager triggerEvent: #do: with: (self value at: 1) asInteger.! !

PPToken subclass: #TelnetDontToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Obsolete'!

!TelnetDontToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:56'!
triggerOn: aEventManager
	aEventManager triggerEvent: #dont: with: (self value at: 1) asInteger.! !

PPToken subclass: #TelnetEcToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Obsolete'!

!TelnetEcToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:05'!
triggerOn: aEventManager
	aEventManager triggerEvent: #ec! !

PPToken subclass: #TelnetElToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Obsolete'!

!TelnetElToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:05'!
triggerOn: aEventManager
	aEventManager triggerEvent: #el! !

PPToken subclass: #TelnetEorToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Obsolete'!

!TelnetEorToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 14:46'!
triggerOn: aEventManager
	aEventManager triggerEvent: #eor! !

PPToken subclass: #TelnetGaToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Obsolete'!

!TelnetGaToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:06'!
triggerOn: aEventManager
	aEventManager triggerEvent: #ga! !

PPToken subclass: #TelnetIpToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Obsolete'!

!TelnetIpToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:06'!
triggerOn: aEventManager
	aEventManager triggerEvent: #ip! !

PPToken subclass: #TelnetNopToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Obsolete'!

!TelnetNopToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:07'!
triggerOn: aEventManager
	aEventManager triggerEvent: #nop! !

PPToken subclass: #TelnetSubnegoToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Obsolete'!

!TelnetSubnegoToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/5/2013 16:37'!
triggerOn: aEventManager
	aEventManager triggerEvent: #subnego: with: self value.! !

PPToken subclass: #TelnetTextToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Obsolete'!

!TelnetTextToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 12:12'!
triggerOn: aEventManager
	aEventManager triggerEvent: #text: with: self value.! !

PPToken subclass: #TelnetWillToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Obsolete'!

!TelnetWillToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:56'!
triggerOn: aEventManager
	aEventManager triggerEvent: #will: with: (self value at: 1) asInteger.! !

PPToken subclass: #TelnetWontToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Obsolete'!

!TelnetWontToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:56'!
triggerOn: aEventManager
	aEventManager triggerEvent: #wont: with: (self value at: 1) asInteger.! !

!Character methodsFor: '*MudTalk' stamp: 'AlexanderSvyazin 1/6/2013 15:37'!
asTelnetCharacter
	^ TelnetCharacter new value: self.! !

TestCase subclass: #MudServerTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Tests'!

!MudServerTests methodsFor: 'tests' stamp: 'AlexanderSvyazin 10/16/2012 23:22'!
testStartStop
	|server|
	server := MudServer new.
	server start.
	self should: [server isStarted].
	self shouldnt: [server isStopped].
	server stop.
	self should: [server isStopped].
	self shouldnt: [server isStarted].! !

!MudServerTests methodsFor: 'tests' stamp: 'AlexanderSvyazin 10/12/2012 23:20'!
testState
	|server|
	server := MudServer new.
	self should: [server isStopped].
	self shouldnt: [server isStarted].! !

!FontFamilyMemberAbstract methodsFor: '*MudTalk-Client' stamp: 'AlexanderSvyazin 1/4/2013 20:56'!
isFixedWidth
	^ (self respondsTo: #fileInfo) ifFalse: [ false ]
		ifTrue: [ self fileInfo fixedWidth ]! !

Object subclass: #MudServer
	instanceVariableNames: 'started'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!MudServer methodsFor: 'initialize-release' stamp: 'AlexanderSvyazin 10/12/2012 23:23'!
initialize
	started := false.! !

!MudServer methodsFor: 'state' stamp: 'AlexanderSvyazin 10/12/2012 23:23'!
isStarted
	^ started.! !

!MudServer methodsFor: 'state' stamp: 'AlexanderSvyazin 10/12/2012 23:21'!
isStopped
	^ started not.! !

!MudServer methodsFor: 'start-stop' stamp: 'AlexanderSvyazin 10/12/2012 23:32'!
start
	started := true.! !

!MudServer methodsFor: 'start-stop' stamp: 'AlexanderSvyazin 10/12/2012 23:33'!
stop
	started := false.! !

Object subclass: #MudTalkClient
	instanceVariableNames: 'window inputPane outputPane outputContents doHandlers willHandlers font telnetOptionHandlers server commandHandlers escapeParser escapeHandlers escapeTextAttributes textAttributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Client'!

!MudTalkClient class methodsFor: 'instance creation' stamp: 'AlexanderSvyazin 1/4/2013 22:25'!
openWindowOnHost: aByteString port: aSmallInteger 
	self new openWindowOnHost: aByteString port: aSmallInteger.! !

!MudTalkClient methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/7/2013 22:22'!
command: aTelnetCommand
	self commandHandlers
		at: aTelnetCommand
		ifPresent: [ :handler | handler value: aTelnetCommand ]
		ifAbsent: [ self unknownCommand: aTelnetCommand ]! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/7/2013 16:12'!
commandHandlers
	^ commandHandlers ifNil: [ commandHandlers := Dictionary new ]! !

!MudTalkClient methodsFor: 'connection' stamp: 'AlexanderSvyazin 1/5/2013 15:23'!
connectTo: aHost port: aPort 
	server := MudTalkConnectionToServer new connectTo: aHost port: aPort.! !

!MudTalkClient methodsFor: 'connection' stamp: 'AlexanderSvyazin 1/4/2013 21:48'!
connectionClosedText
	^ '******* CONNECTION CLOSED *******' asText addAttribute: (TextColor color: Color red)! !

!MudTalkClient methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/10/2013 22:17'!
defaultTextAttribute
	^ TextColor color: Color white! !

!MudTalkClient methodsFor: 'connection' stamp: 'AlexanderSvyazin 1/5/2013 15:23'!
disconnect
	server ifNotNil: [ server terminate ].! !

!MudTalkClient methodsFor: 'connection' stamp: 'AlexanderSvyazin 1/4/2013 21:48'!
disconnected
	self outputText: self connectionClosedText! !

!MudTalkClient methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/4/2013 22:56'!
do: cmd
	telnetOptionHandlers at: cmd
		ifPresent: [ :handler | handler do: cmd ]
		ifAbsent: [ self unknownDoOption: cmd ]! !

!MudTalkClient methodsFor: 'escape parsing' stamp: 'AlexanderSvyazin 1/8/2013 16:40'!
escape: aByteString
	| attributes |
	attributes := self escapeParser textAttributeParser parse: aByteString.
	attributes isPetitFailure
		ifTrue: [ self trace: 'unknown escape: '; traceCr: aByteString ]
		ifFalse: [ self textAttributes: attributes ]! !

!MudTalkClient methodsFor: 'escape parsing' stamp: 'AlexanderSvyazin 1/7/2013 21:46'!
escapeParser
	^ escapeParser ifNil: [ escapeParser := MudTalkEscapeParser new ]! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/2/2013 17:48'!
getInput
	^nil.! !

!MudTalkClient methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/8/2013 16:51'!
initialize
	super initialize.
	self initializeEscapeTextAttributes.
	self initializeTextAttributes.
	self installInputPane.
	self installOutputPane.! !

!MudTalkClient methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/9/2013 23:47'!
initializeEscapeTextAttributes
	escapeTextAttributes := Dictionary new.
	escapeTextAttributes
		at: 0 put: self defaultTextAttribute;
		at: 1 put: TextEmphasis bold;
		at: 30 put: (TextColor color: Color black);
		at: 31 put: (TextColor color: Color red);
		at: 32 put: (TextColor color: Color green);
		at: 33 put: (TextColor color: Color yellow);
		at: 34 put: (TextColor color: Color blue);
		at: 35 put: (TextColor color: Color magenta);
		at: 36 put: (TextColor color: Color cyan);
		at: 37 put: (TextColor color: Color white)! !

!MudTalkClient methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/7/2013 16:08'!
initializeTelnetOptionHandlers
	telnetOptionHandlers := Dictionary new.
	telnetOptionHandlers
		at: TelnetOption suppressGoAhead
		put: (MudTalkClientSuppressGoAheadHandler new server: self server client: self);
		at: TelnetOption terminalType
		put: (MudTalkClientTerminalTypeHandler new server: self server)! !

!MudTalkClient methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/9/2013 23:47'!
initializeTextAttributes
	textAttributes := { self defaultTextAttribute }! !

!MudTalkClient methodsFor: 'private' stamp: 'AlexanderSvyazin 1/10/2013 22:39'!
inputAttributes
	^ { TextColor color: Color lightBrown }! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/10/2013 22:20'!
inputPane
	^ inputPane ifNil: [
		inputPane := self window newTextEditorFor: self getText: #getInput setText: #sendCommand:.
		inputPane textColor: Color white;
			acceptOnCR: true]! !

!MudTalkClient methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/9/2013 23:31'!
installInputPane
	self window
		addMorph: self inputPane
		fullFrame: (LayoutFrame fractions: (0@0.75 extent: 1@1)).! !

!MudTalkClient methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/5/2013 15:58'!
installOutputPane
	self window
		addMorph: self outputPane
		fullFrame: (LayoutFrame fractions: (0@0 extent: 1@0.75)).! !

!MudTalkClient methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/7/2013 15:50'!
openConnectionOn: aHost port: aPort
	self connectTo: aHost port: aPort.
	server events
		when: #disconnected send: #disconnected to: self;
		when: #do: send: #do: to: self;
		when: #dont: send: #dont: to: self;
		when: #will: send: #will: to: self;
		when: #wont: send: #wont: to: self;
		when: #subnego:data: send: #subnego:data: to: self;
		when: #command: send: #command: to: self;
		when: #text: send: #text: to: self! !

!MudTalkClient methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/4/2013 23:08'!
openWindowOnHost: aHost port: aPort
	self openConnectionOn: (NetNameResolver addressForName: aHost) port: aPort.
	self initializeTelnetOptionHandlers.
	self window openInWorld.
	self inputPane takeKeyboardFocus.! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/2/2013 17:39'!
outputContents
	^ outputContents ifNil: [
		outputContents := Text new].! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/10/2013 22:18'!
outputPane
	^ outputPane ifNil: [
		outputPane := self window newTextEditorFor: self getText: #outputContents setText: nil.
		outputPane textColor: Color white]! !

!MudTalkClient methodsFor: 'outputting' stamp: 'AlexanderSvyazin 1/7/2013 21:54'!
outputText: aText
	self outputContents append: aText.
	self changed: #outputContents.
	self outputPane scrollToBottom.! !

!MudTalkClient methodsFor: 'outputting' stamp: 'AlexanderSvyazin 1/10/2013 22:35'!
outputText: aText withAttributes: attributes
	| textCopy |
	textCopy := aText copy.
	attributes do: [ :attr | textCopy addAttribute: attr ].
	self outputText: textCopy! !

!MudTalkClient methodsFor: 'connection' stamp: 'AlexanderSvyazin 1/10/2013 22:38'!
sendCommand: aText
	| textForOutput |
	textForOutput := aText copy.
	textForOutput append: String cr.
	self outputText: textForOutput withAttributes: self inputAttributes.
	server text: aText.
	self changed: #getInput.! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/5/2013 15:25'!
server
	^ server! !

!MudTalkClient methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/7/2013 15:53'!
subnego: anOption data: aByteString
	telnetOptionHandlers at: anOption
		ifPresent: [ :handler | handler subnego: anOption data: aByteString ]
		ifAbsent: [ self unknownSubnego: anOption data: aByteString ]! !

!MudTalkClient methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/7/2013 21:44'!
text: line
	| tokens |
	tokens := self escapeParser parse: line.
	tokens do: [ :token | token triggerOn: self ].! !

!MudTalkClient methodsFor: 'escape parsing' stamp: 'AlexanderSvyazin 1/8/2013 16:48'!
textAttributes: newAttributeCodes
	| newAttributes |
	newAttributes := OrderedCollection new.
	newAttributeCodes do: [ :each | escapeTextAttributes
		at: each
		ifPresent: [ :attr | newAttributes add: attr ] ].
	textAttributes := newAttributes asArray! !

!MudTalkClient methodsFor: 'escape parsing' stamp: 'AlexanderSvyazin 1/10/2013 22:36'!
unescapedText: aString
	self outputText: aString asText withAttributes: textAttributes! !

!MudTalkClient methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/7/2013 16:06'!
unknownCommand: aTelnetCommand
	^ self
		trace: 'unknown telnet command: ';
		traceCr: aTelnetCommand! !

!MudTalkClient methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/4/2013 22:06'!
unknownDoOption: cmd
	self trace: 'unknown DO option: ';
		traceCr: cmd.! !

!MudTalkClient methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/7/2013 15:53'!
unknownSubnego: option data: aByteString 
	self trace: 'unknown SUBNEGO option: ';
		trace: option;
		trace: ', data size: ';
		traceCr: aByteString size.! !

!MudTalkClient methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/4/2013 22:06'!
unknownWillOption: cmd
	self trace: 'unknown WILL option: ';
		traceCr: cmd.! !

!MudTalkClient methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/7/2013 16:21'!
unknownWontOption: anOption 
	self trace: 'unknown WONT option: ';
		traceCr: anOption.! !

!MudTalkClient methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/4/2013 22:57'!
will: cmd
	telnetOptionHandlers at: cmd
		ifPresent: [ :handler | handler will: cmd ]
		ifAbsent: [ self unknownWillOption: cmd ]! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/9/2013 23:02'!
window
	^ window ifNil: [
		window := StandardWindow labelled: 'MUD client'.
		window theme: MudTalkClientTheme new]! !

!MudTalkClient methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/7/2013 16:20'!
wont: anOption 
	telnetOptionHandlers at: anOption
		ifPresent: [ :handler | handler value: anOption ]
		ifAbsent: [ self unknownWontOption: anOption ]! !

Object subclass: #MudTalkClientSuppressGoAheadHandler
	instanceVariableNames: 'server'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Client'!

!MudTalkClientSuppressGoAheadHandler methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/7/2013 16:15'!
ga
	self traceCr: 'GA command received'! !

!MudTalkClientSuppressGoAheadHandler methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/5/2013 15:26'!
server
	^ server.! !

!MudTalkClientSuppressGoAheadHandler methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/7/2013 16:14'!
server: aConnection client: aClient
	server := aConnection.
	aClient commandHandlers at: TelnetCommand GA put: [ :command | self ga ]! !

!MudTalkClientSuppressGoAheadHandler methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/5/2013 15:25'!
will: option 
	(option = TelnetOption suppressGoAhead) ifTrue: [ self server do: TelnetOption suppressGoAhead ]! !

Object subclass: #MudTalkClientTerminalTypeHandler
	instanceVariableNames: 'server'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Client'!

!MudTalkClientTerminalTypeHandler methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/5/2013 16:34'!
bytesForSend
	^ {(TelnetTerminalType send)} asByteArray! !

!MudTalkClientTerminalTypeHandler methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/5/2013 18:11'!
clientTerminalType
	^ 'MudTalk v0.1'! !

!MudTalkClientTerminalTypeHandler methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/5/2013 17:18'!
do: option 
	(option = TelnetOption terminalType) ifTrue: [ self server will: TelnetOption terminalType ]! !

!MudTalkClientTerminalTypeHandler methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/5/2013 16:01'!
server
	^ server! !

!MudTalkClientTerminalTypeHandler methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/5/2013 16:02'!
server: aConnection
	server := aConnection! !

!MudTalkClientTerminalTypeHandler methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/7/2013 15:54'!
subnego: option data: aByteString
	(option = TelnetOption terminalType) ifTrue: [
		self server subnegoStream: [ :stream |
			stream nextPut: TelnetOption terminalType;
				nextPut: TelnetTerminalType is;
				nextPutAll: self clientTerminalType ] ]! !

!MudTalkClientTerminalTypeHandler methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/5/2013 16:34'!
will: option
	option = TelnetOption terminalType
		ifTrue: [ 
			self server do: TelnetOption terminalType.
			self server subnego: self bytesForSend option: TelnetOption terminalType ]! !

Object subclass: #MudTalkConnectionToServer
	instanceVariableNames: 'readingProcess events telnetStream stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Client'!

!MudTalkConnectionToServer methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/7/2013 14:56'!
connectTo: aHost port: aPort
	stream := SocketStream openConnectionToHost: aHost port: aPort.
	telnetStream := TelnetStream on: stream.
	readingProcess := [ self networkReadLoop ] forkNamed: 'MUD client network reading process'.! !

!MudTalkConnectionToServer methodsFor: 'server' stamp: 'AlexanderSvyazin 1/6/2013 23:40'!
do: option
	stream nextPut: TelnetParser iacChar;
		nextPut: TelnetParser doChar;
		nextPut: (Character value: option);
		flush.! !

!MudTalkConnectionToServer methodsFor: 'server' stamp: 'AlexanderSvyazin 1/6/2013 23:40'!
dont: option 
	stream nextPut: TelnetParser iacChar;
		nextPut: TelnetParser dontChar;
		nextPut: (Character value: option);
		flush.! !

!MudTalkConnectionToServer methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/6/2013 23:08'!
events
	^ events ifNil: [ events := EventManager new ]! !

!MudTalkConnectionToServer methodsFor: 'private' stamp: 'AlexanderSvyazin 1/6/2013 23:06'!
networkReadLoop
	[ [ self processTelnetToken ] repeat ]
		on: NetworkError
		do: [ self events triggerEvent: #disconnected ]! !

!MudTalkConnectionToServer methodsFor: 'private' stamp: 'AlexanderSvyazin 1/6/2013 23:06'!
processTelnetToken
	| token |
	token := telnetStream next.
	token triggerOn: self events.! !

!MudTalkConnectionToServer methodsFor: 'server' stamp: 'AlexanderSvyazin 1/5/2013 17:35'!
subnego: aByteArray
	self subnegoStream: [ :strm | strm nextPutAll: aByteArray ].! !

!MudTalkConnectionToServer methodsFor: 'server' stamp: 'AlexanderSvyazin 1/5/2013 17:37'!
subnego: aByteArray option: anOption
	self subnegoStream: [ :strm | strm nextPut: anOption; nextPutAll: aByteArray ]! !

!MudTalkConnectionToServer methodsFor: 'server' stamp: 'AlexanderSvyazin 1/6/2013 23:40'!
subnegoStream: aBlock
	stream nextPut: TelnetParser iacChar;
		nextPut: TelnetParser sbChar.
	aBlock value: stream.
	stream nextPut: TelnetParser iacChar;
		nextPut: TelnetParser seChar; flush.! !

!MudTalkConnectionToServer methodsFor: 'server' stamp: 'AlexanderSvyazin 1/6/2013 23:40'!
text: aText
	stream nextPutAll: aText; crlf; flush! !

!MudTalkConnectionToServer methodsFor: 'server' stamp: 'AlexanderSvyazin 1/6/2013 23:40'!
will: option 
	stream nextPut: TelnetParser iacChar;
		nextPut: TelnetParser willChar;
		nextPut: (Character value: option);
		flush.! !

!MudTalkConnectionToServer methodsFor: 'server' stamp: 'AlexanderSvyazin 1/6/2013 23:40'!
wont: option
	stream nextPut: TelnetParser iacChar;
		nextPut: TelnetParser wontChar;
		nextPut: (Character value: option);
		flush.! !

Object subclass: #MudTalkEscapeParser
	instanceVariableNames: 'parser textAttributeParser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Client'!

!MudTalkEscapeParser methodsFor: 'parsing' stamp: 'AlexanderSvyazin 1/7/2013 21:00'!
CSI
	^ (Character value: 16r1B) asParser, (Character value: 16r5B) asParser! !

!MudTalkEscapeParser methodsFor: 'parsing' stamp: 'AlexanderSvyazin 1/7/2013 20:57'!
F
	^ PPPredicateObjectParser between: (Character value: 16r40) and: (Character value: 16r7E)! !

!MudTalkEscapeParser methodsFor: 'parsing' stamp: 'AlexanderSvyazin 1/7/2013 20:56'!
I
	^ PPPredicateObjectParser between: (Character value: 16r20) and: (Character value: 16r2F)! !

!MudTalkEscapeParser methodsFor: 'parsing' stamp: 'AlexanderSvyazin 1/7/2013 20:55'!
P
	^ PPPredicateObjectParser between: (Character value: 16r30) and: (Character value: 16r3F)! !

!MudTalkEscapeParser methodsFor: 'parsing' stamp: 'AlexanderSvyazin 1/8/2013 17:07'!
escapeParser
	^ (self CSI, self P star, self I star, self F) token: MudTalkEscapeToken! !

!MudTalkEscapeParser methodsFor: 'private' stamp: 'AlexanderSvyazin 1/7/2013 21:09'!
newParser
	^ (self escapeParser / self text) plus end! !

!MudTalkEscapeParser methodsFor: 'parsing' stamp: 'AlexanderSvyazin 1/8/2013 16:12'!
newTextAttributeParser
	^ (self CSI , self numbers , self textAttributeFinisher) end ==> #third! !

!MudTalkEscapeParser methodsFor: 'private' stamp: 'AlexanderSvyazin 1/7/2013 21:32'!
normalChar
	^ (Character value: 16r1B) asParser negate! !

!MudTalkEscapeParser methodsFor: 'parsing' stamp: 'AlexanderSvyazin 1/8/2013 15:50'!
number
	^ #digit asParser plus flatten ==> [ :str | str asInteger ].! !

!MudTalkEscapeParser methodsFor: 'parsing' stamp: 'AlexanderSvyazin 1/8/2013 16:07'!
numbers
	^ (self number separatedBy: self textAttributeDelimiter) ==>
		[ :node | node select: [ :each | each isInteger ] ]! !

!MudTalkEscapeParser methodsFor: 'parsing' stamp: 'AlexanderSvyazin 1/7/2013 20:21'!
parse: aSource
	^ self parser parse: aSource! !

!MudTalkEscapeParser methodsFor: 'private' stamp: 'AlexanderSvyazin 1/7/2013 20:31'!
parser
	^ parser ifNil: [ parser := self newParser ]! !

!MudTalkEscapeParser methodsFor: 'private' stamp: 'AlexanderSvyazin 1/7/2013 21:39'!
text
	^ self normalChar plus ==> [ :chars | MudTalkTextToken on: (String withAll: chars)]! !

!MudTalkEscapeParser methodsFor: 'parsing' stamp: 'AlexanderSvyazin 1/8/2013 15:36'!
textAttributeDelimiter
	^ $; asParser! !

!MudTalkEscapeParser methodsFor: 'parsing' stamp: 'AlexanderSvyazin 1/8/2013 15:37'!
textAttributeFinisher
	^ $m asParser! !

!MudTalkEscapeParser methodsFor: 'parsing' stamp: 'AlexanderSvyazin 1/8/2013 16:31'!
textAttributeParser
	^ textAttributeParser ifNil: [ textAttributeParser := self newTextAttributeParser ]! !

Object subclass: #TelnetCharBuffer
	instanceVariableNames: 'position buffer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetCharBuffer methodsFor: 'writing' stamp: 'AlexanderSvyazin 1/7/2013 15:22'!
add: aCharacter 
	buffer at: position put: aCharacter.
	position := position + 1! !

!TelnetCharBuffer methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/7/2013 15:51'!
clear
	| savedPosition |
	savedPosition := position - 1.
	position := 1.
	^ TelnetText on: buffer from: 1 to: savedPosition! !

!TelnetCharBuffer methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/7/2013 15:23'!
initialize
	buffer := Array new: self size.
	position := 1.! !

!TelnetCharBuffer methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/7/2013 15:23'!
isEmpty
	^ position = 1! !

!TelnetCharBuffer methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/7/2013 15:23'!
isFull
	^ position > self size! !

!TelnetCharBuffer methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/7/2013 15:19'!
size
	^ 4096! !

Object subclass: #TelnetCommand
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetCommand class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/7/2013 16:11'!
GA
	^ 249! !

!TelnetCommand class methodsFor: 'instance creation' stamp: 'AlexanderSvyazin 1/6/2013 16:16'!
value: aCommand 
	^ self new value: aCommand! !

!TelnetCommand methodsFor: 'events' stamp: 'AlexanderSvyazin 1/6/2013 23:22'!
triggerOn: aEventSource
	aEventSource triggerEvent: #command: with: self value! !

!TelnetCommand methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/7/2013 15:58'!
value
	^ value! !

!TelnetCommand methodsFor: 'initialize' stamp: 'AlexanderSvyazin 1/6/2013 16:15'!
value: aCommand 
	value := aCommand! !

Object subclass: #TelnetDo
	instanceVariableNames: 'option'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetDo class methodsFor: 'instance creation' stamp: 'AlexanderSvyazin 1/6/2013 23:38'!
option: anOption 
	^ self new option: anOption! !

!TelnetDo methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/6/2013 23:39'!
option
	^ option! !

!TelnetDo methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/6/2013 23:37'!
option: anOption 
	option := anOption! !

!TelnetDo methodsFor: 'events' stamp: 'AlexanderSvyazin 1/6/2013 23:22'!
triggerOn: aEventSource
	aEventSource triggerEvent: #do: with: self option! !

Object subclass: #TelnetDont
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetDont methodsFor: 'events' stamp: 'AlexanderSvyazin 1/6/2013 23:22'!
triggerOn: aEventSource
	aEventSource triggerEvent: #dont: with: self option! !

Object subclass: #TelnetOption
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetOption class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/5/2013 23:03'!
compess2
	^ 86.! !

!TelnetOption class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/5/2013 23:03'!
compress
	^ 85.! !

!TelnetOption class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/4/2013 15:29'!
eor
	^ 25.! !

!TelnetOption class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/5/2013 23:03'!
gmcp
	^ 201.! !

!TelnetOption class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/5/2013 23:03'!
msp
	^ 90.! !

!TelnetOption class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/5/2013 23:03'!
mxp
	^ 91.! !

!TelnetOption class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/5/2013 23:02'!
naws
	^ 31.! !

!TelnetOption class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/4/2013 13:27'!
suppressGoAhead
	^ 3.! !

!TelnetOption class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/5/2013 16:08'!
terminalType
	^ 24.! !

Object subclass: #TelnetParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Obsolete'!

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/3/2013 23:04'!
anyToken: aTokenClass
	^ #any asParser token: aTokenClass.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/4/2013 10:55'!
ao
	^ (TelnetParser iac , TelnetParser aoChar asParser) token: TelnetAoToken! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
aoChar
	^ Character value: 245.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/4/2013 10:55'!
ayt
 	^ (TelnetParser iac , TelnetParser aytChar asParser) token: TelnetAytToken! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
aytChar
	^ Character value: 246.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/4/2013 10:54'!
brk
	^ (TelnetParser iac , TelnetParser brkChar asParser) token: TelnetBrkToken! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
brkChar
	^ Character value: 243.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/4/2013 10:54'!
dm
	^ (TelnetParser iac , TelnetParser dmChar asParser) token: TelnetDmToken! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
dmChar
	^ Character value: 242.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/3/2013 23:00'!
do
	^ (TelnetParser iac,
		TelnetParser doChar asParser,
		(TelnetParser anyToken: TelnetDoToken)) ==>
			[:parts | parts at: 3].! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
doChar
	^ Character value: 253.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/3/2013 23:01'!
dont
	^ (TelnetParser iac,
		TelnetParser dontChar asParser,
		(TelnetParser anyToken: TelnetDontToken)) ==>
			[:parts | parts at: 3].! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
dontChar
	^ Character value: 254.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/4/2013 10:54'!
ec
	^ (TelnetParser iac , TelnetParser ecChar asParser) token: TelnetEcToken! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
ecChar
	^ Character value: 247.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/4/2013 10:54'!
el
	^ (TelnetParser iac , TelnetParser elChar asParser) token: TelnetElToken! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
elChar
	^ Character value: 248.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/4/2013 14:45'!
eor
	^ (TelnetParser iac, TelnetParser eorChar asParser) token: TelnetEorToken.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/4/2013 14:44'!
eorChar
	^ Character value: 239.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/4/2013 15:33'!
eorDelimiter
	^ String with: TelnetParser iacChar with: TelnetParser eorChar.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/4/2013 10:53'!
ga
	^ (TelnetParser iac , TelnetParser gaChar asParser) token: TelnetGaToken! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
gaChar
	^ Character value: 249.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/3/2013 22:52'!
iac
	^ TelnetParser iacChar asParser.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
iacChar
	^ Character value: 255.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/3/2013 23:04'!
iaciac
	^ (TelnetParser iac, TelnetParser iac)
		answer: TelnetParser iacChar.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/4/2013 10:53'!
ip
	^ (TelnetParser iac , TelnetParser ipChar asParser) token: TelnetIpToken! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
ipChar
	^ Character value: 244.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/4/2013 10:53'!
nop
	^ (TelnetParser iac , TelnetParser nopChar asParser) token: TelnetNopToken! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
nopChar
	^ Character value: 241.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/3/2013 23:08'!
normalChar
	^ TelnetParser iaciac / TelnetParser iac negate.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/3/2013 22:45'!
parser
	^ (TelnetParser special / TelnetParser text) star end.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/5/2013 17:55'!
sb
	^ (TelnetParser iac, TelnetParser sbChar asParser) answer: #sb! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
sbChar
	^ Character value: 250.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/5/2013 17:55'!
se
	^ (TelnetParser iac, TelnetParser seChar asParser) answer: #se! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
seChar
	^ Character value: 240.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/5/2013 15:54'!
special
	^ TelnetParser nop /
		TelnetParser dm /
		TelnetParser brk /
		TelnetParser ip /
		TelnetParser ao /
		TelnetParser ayt /
		TelnetParser ec /
		TelnetParser el /
		TelnetParser ga /
		TelnetParser do /
		TelnetParser dont /
		TelnetParser will /
		TelnetParser wont /
		TelnetParser subnego.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/5/2013 18:00'!
subnego
	^ TelnetParser sb, (TelnetParser normalChar plus token: TelnetSubnegoToken), TelnetParser se ==>
		[ :parts | parts at: 2 ]! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/4/2013 10:46'!
text
	^ TelnetParser normalChar plus ==> [:chars | TelnetTextToken on: (String withAll: chars)].! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/3/2013 23:01'!
will
	^ (TelnetParser iac,
		TelnetParser willChar asParser,
		(TelnetParser anyToken: TelnetWillToken)) ==>
			[:parts | parts at: 3].! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/4/2013 11:31'!
willChar
	^ Character value: 251.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/3/2013 23:01'!
wont
	^ (TelnetParser iac,
		TelnetParser wontChar asParser,
		(TelnetParser anyToken: TelnetWontToken)) ==>
			[:parts | parts at: 3].! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
wontChar
	^ Character value: 252.! !

Object subclass: #TelnetStream
	instanceVariableNames: 'stream iacHandlers charBuffer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetStream class methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/6/2013 16:10'!
DO
	^ Character value: 253.! !

!TelnetStream class methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/6/2013 16:10'!
DONT
	^ Character value: 254.! !

!TelnetStream class methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/6/2013 15:39'!
IAC
	^ Character value: 255! !

!TelnetStream class methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/6/2013 16:10'!
SB
	^ Character value: 250.! !

!TelnetStream class methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/6/2013 16:10'!
SE
	^ Character value: 240.! !

!TelnetStream class methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/6/2013 16:10'!
WILL
	^ Character value: 251.! !

!TelnetStream class methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/6/2013 16:10'!
WONT
	^ Character value: 252 .! !

!TelnetStream class methodsFor: 'instance creation' stamp: 'AlexanderSvyazin 1/6/2013 16:21'!
on: aSource 
	^ self new source: aSource! !

!TelnetStream class methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/6/2013 16:23'!
subnegoEnd
	^ {TelnetStream IAC. TelnetStream SE}! !

!TelnetStream methodsFor: 'reading' stamp: 'AlexanderSvyazin 1/6/2013 16:00'!
iacDoNext
	^ TelnetDo option: self readOption! !

!TelnetStream methodsFor: 'reading' stamp: 'AlexanderSvyazin 1/6/2013 16:00'!
iacDontNext
	^ TelnetDont option: self readOption! !

!TelnetStream methodsFor: 'reading' stamp: 'AlexanderSvyazin 1/7/2013 15:12'!
iacNext
	| c |
	c := stream next.
	(c = TelnetStream IAC)
		ifTrue: [
			charBuffer add: TelnetStream IAC.
			charBuffer isFull isTrue: [ ^ charBuffer clear ].
			^ self next ]
		ifFalse: [
			iacHandlers at: c
				ifPresent: [ :handler | ^ handler value ]
				ifAbsent: [ ^ TelnetCommand value: c asInteger ] ]
	! !

!TelnetStream methodsFor: 'reading' stamp: 'AlexanderSvyazin 1/6/2013 16:23'!
iacSbNext
	| option data |
	option := self readOption.
	data := stream upToAll: TelnetStream subnegoEnd.
	^ TelnetSubnego option: option data: data! !

!TelnetStream methodsFor: 'reading' stamp: 'AlexanderSvyazin 1/6/2013 16:01'!
iacWillNext
	^ TelnetWill option: self readOption! !

!TelnetStream methodsFor: 'reading' stamp: 'AlexanderSvyazin 1/6/2013 16:01'!
iacWontNext
	^ TelnetWont option: self readOption! !

!TelnetStream methodsFor: 'initializing' stamp: 'AlexanderSvyazin 1/7/2013 15:17'!
initialize
	super initialize.
	charBuffer := TelnetCharBuffer new.
	iacHandlers := Dictionary new.
	iacHandlers at: TelnetStream DO put: [ self iacDoNext ].
	iacHandlers at: TelnetStream DONT put: [ self iacDontNext ].
	iacHandlers at: TelnetStream WILL put: [ self iacWillNext ].
	iacHandlers at: TelnetStream WONT put: [ self iacWontNext ].
	iacHandlers at: TelnetStream SB put: [ self iacSbNext ].! !

!TelnetStream methodsFor: 'reading' stamp: 'AlexanderSvyazin 1/7/2013 20:01'!
next
	| c |
	[ stream isDataAvailable ifFalse: [ charBuffer isEmpty ifFalse: [ ^ charBuffer clear ] ].
		c := stream next.
		(c = TelnetStream IAC) ifTrue: [ ^ self iacNext ].
		charBuffer add: c.
		charBuffer isFull ifTrue: [ ^ charBuffer clear ] ] repeat.! !

!TelnetStream methodsFor: 'reading' stamp: 'AlexanderSvyazin 1/6/2013 16:00'!
readOption
	^ stream next asInteger! !

!TelnetStream methodsFor: 'initializing' stamp: 'AlexanderSvyazin 1/6/2013 16:21'!
source: aSource 
	stream := aSource! !

Object subclass: #TelnetSubnego
	instanceVariableNames: 'option data'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetSubnego class methodsFor: 'instance creation' stamp: 'AlexanderSvyazin 1/7/2013 15:31'!
option: anOption data: aByteString
	^ self new option: anOption data: aByteString! !

!TelnetSubnego methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/7/2013 15:33'!
data
	^ data! !

!TelnetSubnego methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/7/2013 15:33'!
option
	^ option! !

!TelnetSubnego methodsFor: 'events' stamp: 'AlexanderSvyazin 1/7/2013 15:32'!
option: anOption data: aByteString
	option := anOption.
	data := aByteString.! !

!TelnetSubnego methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/7/2013 15:34'!
triggerOn: aEventSource
	aEventSource triggerEvent: #subnego:data: withArguments: {self option. self data}! !

Object subclass: #TelnetTerminalType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetTerminalType class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/5/2013 18:10'!
is
	^ 0.! !

!TelnetTerminalType class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/5/2013 16:19'!
send
	^ 1.! !

Object subclass: #TelnetText
	instanceVariableNames: 'collection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetText class methodsFor: 'instance creation' stamp: 'AlexanderSvyazin 1/7/2013 15:37'!
on: aCollection from: start to: stop
	^ self new on: aCollection from: start to: stop! !

!TelnetText methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/7/2013 15:41'!
collection
	^ collection! !

!TelnetText methodsFor: 'events' stamp: 'AlexanderSvyazin 1/7/2013 15:45'!
on: aCollection from: start to: stop 
	collection := aCollection copyFrom: start to: stop! !

!TelnetText methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/7/2013 15:46'!
triggerOn: anEventSource
	anEventSource triggerEvent: #text: with: (String withAll: self collection)! !

Object subclass: #TelnetWill
	instanceVariableNames: 'option'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetWill class methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/6/2013 23:41'!
option: anOption 
	^ self new option: anOption! !

!TelnetWill methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/6/2013 23:42'!
option
	^ option! !

!TelnetWill methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/6/2013 23:42'!
option: anOption 
	option := anOption! !

!TelnetWill methodsFor: 'events' stamp: 'AlexanderSvyazin 1/6/2013 23:25'!
triggerOn: aEventSource
	aEventSource triggerEvent: #will: with: self option! !

Object subclass: #TelnetWont
	instanceVariableNames: 'option'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetWont class methodsFor: 'instance creation' stamp: 'AlexanderSvyazin 1/7/2013 16:18'!
option: anOption 
	^ self new option: anOption! !

!TelnetWont methodsFor: 'accesing' stamp: 'AlexanderSvyazin 1/7/2013 16:19'!
option
	^ option! !

!TelnetWont methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/7/2013 16:19'!
option: anOption 
	option := anOption! !

!TelnetWont methodsFor: 'events' stamp: 'AlexanderSvyazin 1/6/2013 23:25'!
triggerOn: aEventSource
	aEventSource triggerEvent: #wont: with: self option! !

PharoTheme subclass: #MudTalkClientTheme
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Client'!

!MudTalkClientTheme methodsFor: 'fonts' stamp: 'AlexanderSvyazin 1/9/2013 23:34'!
fixedWidthFontFamily
	^ (LogicalFontManager current fixedWidthFamilies at: 1) familyName! !

!MudTalkClientTheme methodsFor: 'fonts' stamp: 'AlexanderSvyazin 1/9/2013 23:34'!
fontSize
	^ 10! !

!MudTalkClientTheme methodsFor: 'fill-styles' stamp: 'AlexanderSvyazin 1/9/2013 23:37'!
textEditorNormalFillStyleFor: aTextEditor
	^ Color black! !

!MudTalkClientTheme methodsFor: 'fonts' stamp: 'AlexanderSvyazin 1/9/2013 23:34'!
textFont
	^ LogicalFont familyName: (self fixedWidthFontFamily) pointSize: self fontSize! !
